Loading...
Searching...
No Matches
Http_date

## Macros

#define | HTTP_DATE_INIT()
| Initializer for structure http_date_t.
#define | HTTPTAG_DATE(x)
| Tag list item for pointer to a Date header object.
#define | HTTPTAG_DATE_STR(s)
| Tag list item for string with Date header value.

## Typedefs

typedef struct http_date_s | http_date_t
| @HTTP_HEADER http_content_type Content-Type header.

## Enumerations

enum | { http_date_hash }

## Functions

http_date_t * | http_date_init (http_date_t x[1])
| Initialize a structure http_date_t.
int | http_is_date (http_header_t const *header)
| Test if header object is instance of http_date_t.
http_date_t * | http_date_dup (su_home_t *home, http_date_t const *hdr))
| Duplicate (deep copy) `http_date_t`.
http_date_t * | http_date_copy (su_home_t *home, http_date_t const *hdr))
| Copy a http_date_t header structure.
http_date_t * | http_date_make (su_home_t *home, char const *s))
| Make a header structure http_date_t.
http_date_t * | http_date_format (su_home_t *home, char const *fmt,...)))
| Make a Date header from formatting result.
http_date_t * | http_date_create (su_home_t *home, http_time_t date)
| Create an Date header object.

## Variables

msg_hclass_t | http_date_class []
| Header class for HTTP Date header.
msg_parse_f | http_date_d
| Decode (parse) a Date header.
msg_print_f | http_date_e
| Encode (print) a Date header.

## Detailed Description

## Macro Definition Documentation

## HTTP_DATE_INIT

#define HTTP_DATE_INIT | ( |  | ) |

Initializer for structure http_date_t.

A static http_date_t structure must be initialized with the HTTP_DATE_INIT() macro. For instance,

http_date_t http_date = HTTP_DATE_INIT;
HTTP_DATE_INIT
#define HTTP_DATE_INIT()
Initializer for structure http_date_t.
Definition http_protos.h:3342
http_date_t
struct http_date_s http_date_t
@HTTP_HEADER http_content_type Content-Type header.
Definition http.h:123

## HTTPTAG_DATE

#define HTTPTAG_DATE | ( |  | x | ) |

Tag list item for pointer to a Date header object.

The HTTPTAG_DATE() macro is used to include a tag item with a pointer to a http_date_t object in a tag list.

Parameters

  x | pointer to a http_date_t header structure, or NULL.

## HTTPTAG_DATE_STR

#define HTTPTAG_DATE_STR | ( |  | s | ) |

Tag list item for string with Date header value.

The HTTPTAG_DATE_STR() macro is used to include a tag item with a string containing value of a http_date_t header in a tag list.

Parameters

  s | pointer to a string containing http_date_t value, or NULL.

The HTTPTAG_DATE_STR string can be converted to a http_date_t header structure by giving the string s has second argument to function http_date_make().

## Typedef Documentation

## http_date_t

typedef struct http_date_s http_date_t

@HTTP_HEADER http_content_type Content-Type header.

We use MIME Content-Type header. @HTTP_HEADER http_date Date header.

The Date header field reflects the time when the request or response was first sent. Its syntax is defined in [H14.18] as follows:

Date = "Date" HCOLON HTTP-date
HTTP-date = rfc1123-date
rfc1123-date = wkday "," SP date1 SP time SP "GMT"
date1 = 2DIGIT SP month SP 4DIGIT
; day month year (e.g., 02 Jun 1982)
time = 2DIGIT ":" 2DIGIT ":" 2DIGIT
; 00:00:00 - 23:59:59
wkday = "Mon" / "Tue" / "Wed"
/ "Thu" / "Fri" / "Sat" / "Sun"
month = "Jan" / "Feb" / "Mar" / "Apr"
/ "May" / "Jun" / "Jul" / "Aug"
/ "Sep" / "Oct" / "Nov" / "Dec"
DIGIT
#define DIGIT
SP
#define SP

The structure http_date_t contains representation of Date header.

The http_date_t is defined as follows:

typedef struct {
msg_common_t d_common[1]; // Common fragment info
msg_error_t *d_next; // Link to next (dummy)
http_time_t d_time; // Seconds since Jan 1, 1900
} http_date_t;
msg_error_t
struct msg_error_s msg_error_t
http_time_t
unsigned long http_time_t
Time in seconds since 01-Jan-1900.
Definition http.h:169
msg_common_t
struct msg_common_s msg_common_t

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
http_date_hash | Hash of Date header.

## Function Documentation

## http_date_copy()

http_date_t * http_date_copy | ( | su_home_t * | home,
|  | http_date_t const * | hdr )

inline

Copy a http_date_t header structure.

The function http_date_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be duplicated

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old header, including the encoding of the old header, if present.

Example
  date = http_date_copy(home, http->http_date);
  http_date_copy
  http_date_t * http_date_copy(su_home_t *home, http_date_t const *hdr))
  Copy a http_date_t header structure.
  Definition http_protos.h:3536

Returns
  The function http_date_copy() returns a pointer to newly copied header structure, or NULL upon an error.

## http_date_create()

http_date_t * http_date_create | ( | su_home_t * | home,
|  | http_time_t | date )

Create an Date header object.

The function http_date_create() creates a Date header object with the date date. If

Date
  is 0, current time (as returned by msg_now()) is used.

Parameters

  home | memory home
  date | date expressed as seconds since Mon, 01 Jan 1900 00:00:00

Returns
  The function http_date_create() returns a pointer to newly created Date header object when successful, or NULL upon an error.

## http_date_dup()

http_date_t * http_date_dup | ( | su_home_t * | home,
|  | http_date_t const * | hdr )

inline

Duplicate (deep copy) `http_date_t`.

The function http_date_dup() duplicates a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  date = http_date_dup(home, http->http_date);
  http_date_dup
  http_date_t * http_date_dup(su_home_t *home, http_date_t const *hdr))
  Duplicate (deep copy) http_date_t.
  Definition http_protos.h:3529

Returns
  The function http_date_dup() returns a pointer to the newly duplicated http_date_t header structure, or NULL upon an error.

## http_date_format()

http_date_t * http_date_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Date header from formatting result.

The function http_date_format() makes a new Date header object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and uses the formatting result as the header value.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Note
  This function is usually implemented as a macro calling msg_header_format().

Returns
  The function http_date_format() returns a pointer to newly makes header structure, or NULL upon an error.

## http_date_init()

http_date_t * http_date_init | ( | http_date_t | x[1] | ) |

inline

Initialize a structure http_date_t.

An http_date_t structure can be initialized with the http_date_init() function/macro. For instance,

http_date_t http_date;
http_date_init(&http_date);
http_date_init
http_date_t * http_date_init(http_date_t x[1])
Initialize a structure http_date_t.
Definition http_protos.h:3358

## http_date_make()

http_date_t * http_date_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a header structure http_date_t.

The function http_date_make() makes a new http_date_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Note
  This function is usually implemented as a macro calling http_header_make().

Returns
  The function http_date_make() returns a pointer to newly maked http_date_t header structure, or NULL upon an error.

## http_is_date()

int http_is_date | ( | http_header_t const * | header | ) |

inline

Test if header object is instance of http_date_t.

The function http_is_date() returns true (nonzero) if the header class is an instance of Date header object and false (zero) otherwise.

Parameters

  header | pointer to the header structure to be tested

Returns
  The function http_is_xdate() returns true (nonzero) if the header object is an instance of header date and false (zero) otherwise.

## Variable Documentation

## http_date_class

msg_hclass_t http_date_class[]

extern

Header class for HTTP Date header.

The header class http_date_class defines how a HTTP Date header is parsed and printed. It also contains methods used by HTTP parser and other functions to manipulate the http_date_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.